| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Geometry::BinIDSurface Class Reference
Geometry

`#include <binidsurface.h>`

Inheritance diagram for Geometry::BinIDSurface:
[legend]

## Public Member Functions
| BinIDSurface (const BinID &step)
| BinIDSurface (const BinIDSurface &)
| ~BinIDSurface ()
BinIDSurface * | clone () const override
StepInterval< int > | colRange () const override
StepInterval< int > | colRange (int row) const override
Coord3 | computePosition (const Coord &param) const override
bool | expandWithUdf (const BinID &start, const BinID &stop)
Array2D< float > * | getArray ()
const Array2D< float > * | getArray () const
Coord3 | getKnot (const RowCol &, bool computeifudf) const override
virtual Coord3 | getKnot (const RowCol &rc) const override
Coord | getKnotCoord (const RowCol &) const
RowCol | getNearestKnotRowCol (Coord) const
void | getPosIDs (TypeSet< GeomPosID > &, bool rmudf=true) const override
bool | insertCol (int col, int nrnew=1) override
bool | insertRow (int row, int nrnew=1) override
bool | isEmpty () const override
Coord3 | lineSegmentIntersection (Coord3, Coord3, float zshift=0.0)
bool | removeCol (int, int) override
bool | removeRow (int, int) override
StepInterval< int > | rowRange () const override
StepInterval< int > | rowRange (int col) const override
void | setArray (const BinID &start, const BinID &step, Array2D< float > *, bool takeover)
Interval< float > | zRange ()
Interval< float > | zRange (Coord, Coord) const
Public Member Functions inherited from Geometry::ParametricSurface
| ~ParametricSurface ()
bool | checkSelfIntersection (bool yn)
bool | checksSelfIntersection () const
bool | checksSupport () const
bool | checkSupport (bool yn)
virtual bool | circularCols () const
virtual bool | circularRows () const
StepInterval< int > | colRange () const override
StepInterval< int > | colRange (int row) const override
virtual Coord3 | computeNormal (const Coord &) const
virtual ParametricCurve * | createColCurve (float col, const Interval< int > *rowrange=0) const
virtual ParametricCurve * | createRowCurve (float row, const Interval< int > *colrange=0) const
Coord3 | getKnot (const RowCol &) const override
int | getKnotIndex (const RowCol &rc) const
RowCol | getKnotRowCol (int idx) const
Coord3 | getPosition (GeomPosID pid) const override
bool | hasSupport (const RowCol &) const
bool | isAtEdge (const RowCol &) const
bool | isDefined (GeomPosID pid) const override
bool | isKnotDefined (const RowCol &) const override
int | nrKnots () const
StepInterval< int > | rowRange () const override
bool | setKnot (const RowCol &, const Coord3 &) override
bool | setPosition (GeomPosID pid, const Coord3 &) override
void | trimUndefParts () override
virtual bool | unsetKnot (const RowCol &)
Public Member Functions inherited from Geometry::RowColSurface
| ~RowColSurface ()
Iterator * | createIterator () const override
void | getPosIDs (TypeSet< GeomPosID > &, bool=true) const override
Coord3 | getPosition (GeomPosID pid) const override
bool | isDefined (GeomPosID pid) const override
bool | setPosition (GeomPosID pid, const Coord3 &) override
Public Member Functions inherited from Geometry::Element
| Element ()
| Element (const Element &)
virtual | ~Element ()
void | blockCallBacks (bool yn, bool flush=true)
bool | blocksCallBacks () const
virtual IntervalND< float > | boundingBox (bool approx) const
virtual uiString | errMsg () const
virtual bool | isChanged () const
Element & | operator= (const Element &)
virtual void | resetChangedFlag ()
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()

## Protected Member Functions
void | _setKnot (int idx, const Coord3 &) override
int | nrCols () const override
int | nrRows () const override
Protected Member Functions inherited from Geometry::ParametricSurface
| ParametricSurface (const RowCol &origin=RowCol(0, 0), const RowCol &step=RowCol(1, 1))
virtual bool | checkSelfIntersection (const RowCol &) const
int | colIndex (int col) const
bool | isAtSameEdge (const RowCol &, const RowCol &, TypeSet< RowCol > *=0) const
int | rowIndex (int row) const
Protected Member Functions inherited from Geometry::RowColSurface
| RowColSurface ()
Protected Member Functions inherited from Geometry::Element
uiString & | errmsg ()
void | triggerMovement ()
void | triggerMovement (const GeomPosID &)
void | triggerMovement (const TypeSet< GeomPosID > &)
void | triggerNrPosCh ()
void | triggerNrPosCh (const GeomPosID &)
void | triggerNrPosCh (const TypeSet< GeomPosID > &)

## Protected Attributes
Array2D< float > * | depths_
const SurveyInfo * | surveyinfo_
Interval< float > | zrange_
Protected Attributes inherited from Geometry::ParametricSurface
bool | checkselfintersection_
bool | checksupport_
RowCol | origin_
RowCol | step_
Protected Attributes inherited from Geometry::Element
bool | blockcbs_ = false
bool | ischanged_ = false
TypeSet< GeomPosID > | movementbuffer_
TypeSet< GeomPosID > | nrposchbuffer_

## Additional Inherited Members
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Public Attributes inherited from Geometry::Element
CNotifier< Element, const TypeSet< GeomPosID > * > | movementnotifier
CNotifier< Element, const TypeSet< GeomPosID > * > | nrpositionnotifier
Static Protected Member Functions inherited from Geometry::ParametricSurface
static int | colDim ()
static int | rowDim ()

## Detailed Description

<>

## Constructor & Destructor Documentation

## ◆ BinIDSurface() [1/2]

Geometry::BinIDSurface::BinIDSurface | ( | const BinID & | step | ) |

## ◆ BinIDSurface() [2/2]

Geometry::BinIDSurface::BinIDSurface | ( | const BinIDSurface & |  | ) |

## ◆ ~BinIDSurface()

Geometry::BinIDSurface::~BinIDSurface | ( |  | ) |

## Member Function Documentation

## ◆ _setKnot()

void Geometry::BinIDSurface::_setKnot | ( | int | idx,
|  | const Coord3 & | )
| override protected virtual

Implements Geometry::ParametricSurface.

## ◆ clone()

BinIDSurface * Geometry::BinIDSurface::clone | ( |  | ) | const
| override virtual

Implements Geometry::ParametricSurface.

## ◆ colRange() [1/2]

StepInterval< int > Geometry::BinIDSurface::colRange | ( |  | ) | const
| override virtual

Reimplemented from Geometry::RowColSurface.

## ◆ colRange() [2/2]

StepInterval< int > Geometry::BinIDSurface::colRange | ( | int | row | ) | const
| override virtual

Implements Geometry::RowColSurface.

## ◆ computePosition()

Coord3 Geometry::BinIDSurface::computePosition | ( | const Coord & | param | ) | const
| override virtual

Reimplemented from Geometry::ParametricSurface.

## ◆ expandWithUdf()

bool Geometry::BinIDSurface::expandWithUdf | ( | const BinID & | start,
|  | const BinID & | stop )

## ◆ getArray() [1/2]

Array2D< float > * Geometry::BinIDSurface::getArray | ( |  | ) |
| inline

## ◆ getArray() [2/2]

const Array2D< float > * Geometry::BinIDSurface::getArray | ( |  | ) | const
| inline

## ◆ getKnot() [1/2]

Coord3 Geometry::BinIDSurface::getKnot | ( | const RowCol & | ,
|  | bool | computeifudf ) const
| override virtual

Implements Geometry::ParametricSurface.

## ◆ getKnot() [2/2]

virtual Coord3 Geometry::BinIDSurface::getKnot | ( | const RowCol & | rc | ) | const
| inline override virtual

Implements Geometry::RowColSurface.

## ◆ getKnotCoord()

Coord Geometry::BinIDSurface::getKnotCoord | ( | const RowCol & |  | ) | const

## ◆ getNearestKnotRowCol()

RowCol Geometry::BinIDSurface::getNearestKnotRowCol | ( | Coord |  | ) | const

## ◆ getPosIDs()

void Geometry::BinIDSurface::getPosIDs | ( | TypeSet< GeomPosID > & | ,
|  | bool | rmudf = true ) const
| override virtual

Reimplemented from Geometry::Element.

## ◆ insertCol()

bool Geometry::BinIDSurface::insertCol | ( | int | col,
|  | int | nrnew = 1 )
| override virtual

Implements Geometry::ParametricSurface.

## ◆ insertRow()

bool Geometry::BinIDSurface::insertRow | ( | int | row,
|  | int | nrnew = 1 )
| override virtual

Implements Geometry::ParametricSurface.

## ◆ isEmpty()

bool Geometry::BinIDSurface::isEmpty | ( |  | ) | const
| inline override virtual

Implements Geometry::RowColSurface.

## ◆ lineSegmentIntersection()

Coord3 Geometry::BinIDSurface::lineSegmentIntersection | ( | Coord3 | ,
|  | Coord3 | ,
|  | float | zshift = 0.0 )

## ◆ nrCols()

int Geometry::BinIDSurface::nrCols | ( |  | ) | const
| override protected virtual

Implements Geometry::ParametricSurface.

## ◆ nrRows()

int Geometry::BinIDSurface::nrRows | ( |  | ) | const
| override protected virtual

Implements Geometry::ParametricSurface.

## ◆ removeCol()

bool Geometry::BinIDSurface::removeCol | ( | int | ,
|  | int | )
| override virtual

Reimplemented from Geometry::ParametricSurface.

## ◆ removeRow()

bool Geometry::BinIDSurface::removeRow | ( | int | ,
|  | int | )
| override virtual

Reimplemented from Geometry::ParametricSurface.

## ◆ rowRange() [1/2]

StepInterval< int > Geometry::BinIDSurface::rowRange | ( |  | ) | const
| override virtual

Implements Geometry::RowColSurface.

## ◆ rowRange() [2/2]

StepInterval< int > Geometry::BinIDSurface::rowRange | ( | int | col | ) | const
| override virtual

Reimplemented from Geometry::ParametricSurface.

## ◆ setArray()

void Geometry::BinIDSurface::setArray | ( | const BinID & | start,
|  | const BinID & | step,
|  | Array2D< float > * | ,
|  | bool | takeover )

Mem is taken over by me if takeover is true.

## ◆ zRange() [1/2]

Interval< float > Geometry::BinIDSurface::zRange | ( |  | ) |

## ◆ zRange() [2/2]

Interval< float > Geometry::BinIDSurface::zRange | ( | Coord | ,
|  | Coord | ) const

## Member Data Documentation

## ◆ depths_

Array2D<float>* Geometry::BinIDSurface::depths_
| protected

## ◆ surveyinfo_

const SurveyInfo* Geometry::BinIDSurface::surveyinfo_
| protected

## ◆ zrange_

Interval<float> Geometry::BinIDSurface::zrange_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025